<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Title</title>
    <!-- Required meta tags -->
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1, shrink-to-fit=no"
    />

    <!-- Bootstrap CSS -->
    <link
      rel="stylesheet"
      href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
      integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T"
      crossorigin="anonymous"
    />
  </head>
  <body onload="onPageLoadingOrder()">
    <div class="container">
      <h1>OrderDetail!!!</h1>
      <label for="">Order Code(mã đơn hàng)</label>
      <input type="text" name="" id="inp-ordercode" class="form-control" />
      <label for="">Cỡ combo</label>
      <select name="" id="select-co-combo" class="form-control">
        <option value="">Chọn Cỡ combo</option>
        <option value="">Nhỏ(S)</option>
        <option value="">Vừa(M)</option>
        <option value="">Lớn(L)</option>
      </select>
      <label for="">Đường kính Pizza</label>
      <input type="text" name="" id="inp-duong-kinh" class="form-control" />
      <label for="">Sườn nướng(miếng)</label>
      <input type="text" name="" id="inp-suon-nuong" class="form-control" />
      <label for="">Đồ uống</label>
      <select name="" id="select-drink" class="form-control">
        <option value="">Chọn nước uống</option>
      </select>
      <label for="">Số lượng nước uống</label>
      <input type="text" name="" id="inp-so-luong-nuoc" class="form-control" />
      <label for="">Voucher ID</label>
      <input type="text" name="" id="inp-id-voucher" class="form-control" />
      <label for="">Loại pizza</label>
      <select name="" id="select-loai-pizza" class="form-control">
        <option value="">Chọn loại pizza</option>
        <option value="">Gà</option>
        <option value="">Hải sản</option>
        <option value="">Thịt nướng</option>
      </select>
      <label for="">Salad</label>
      <input type="text" name="" id="inp-salad" class="form-control" />
      <label for="">Thành tiền</label>
      <input type="text" name="" id="inp-thanh-tien" class="form-control" />
      <label for="">Giảm giá</label>
      <input type="text" name="" id="inp-giam-gia" class="form-control" />
      <label for="">Họ và tên</label>
      <input type="text" name="" id="inp-ho-ten" class="form-control" />
      <label for="">Email</label>
      <input type="text" name="" id="inp-email" class="form-control" />
      <label for="">Số điện thoại</label>
      <input type="text" name="" id="inp-so-dien-thoai" class="form-control" />
      <label for="">Địa chỉ</label>
      <input type="text" name="" id="inp-dia-chi" class="form-control" />
      <label for="">Lời nhắn</label>
      <input type="text" name="" id="inp-loi-nhan" class="form-control" />
      <label for="">Trạng thái đơn hàng</label>
      <input type="text" name="" id="inp-trang-thai" class="form-control" />
      <label for="">Ngày tạo đơn</label>
      <input type="text" name="" id="inp-ngay-tao" class="form-control" />
      <label for="">Ngày cập nhật</label>
      <input type="text" name="" id="inp-ngay-cap-nhat" class="form-control" />

      <button class="btn btn-success mt-3" onclick="onBtnUpdateConfirm()">
        Confirm
      </button>
      <button class="btn btn-info mt-3" onclick="onBtnUpdateCancle()">
        Cancel
      </button>
      <button class="btn btn-info mt-3" onclick="onBtnBack()">Back</button>
    </div>
    <hr />
    <hr />
    <hr />
    <hr />
    <hr />

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gREQUEST_STATUS_OK = 200;
      const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
      //base url
      const gBASE_URL_ORDER =
        "http://203.171.20.210:8080/devcamp-pizza365/orders";
      const gBASE_URL_DRINK =
        "http://203.171.20.210:8080/devcamp-pizza365/drinks";
      var gURL = window.location.href;
      var gURLString = new URL(gURL);
      var gOrderCode = gURLString.searchParams.get("orderCode");
      console.log("orderCode:" + gOrderCode);
      var gId = gURLString.searchParams.get("id");
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      // đổ dữ lieuj vào inout
      function onPageLoadingOrder() {
        var vXmlHttp = new XMLHttpRequest();
        goiApiDeLayDrink(vXmlHttp);
        hienThiThongTinNuoc(vXmlHttp);
        goiApiDeLayOrder(vXmlHttp);
        vXmlHttp.onreadystatechange = function () {
          if (
            vXmlHttp.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            vXmlHttp.status == gREQUEST_STATUS_OK
          ) {
            console.log(vXmlHttp.responseText);
            hienThiThongTinOrder(vXmlHttp);
          }
        };
      }
      // update trạng thái
      function onBtnUpdateCancle() {
        var vOrderObj = {
          trangThai: "cancle",
        };
        var vXmlHttp = new XMLHttpRequest();
        goiApiUpdateOrder(vOrderObj, vXmlHttp);
        vXmlHttp.onreadystatechange = function () {
          if (
            vXmlHttp.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            vXmlHttp.status == gREQUEST_STATUS_OK
          ) {
            alert("update thanh cong");
            onBtnBack();
          }
        };
      }
      // update trạng thái
      function onBtnUpdateConfirm() {
        var vOrderObj = {
          trangThai: "confirmed",
        };
        var vXmlHttp = new XMLHttpRequest();
        goiApiUpdateOrder(vOrderObj, vXmlHttp);
        vXmlHttp.onreadystatechange = function () {
          if (
            vXmlHttp.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            vXmlHttp.status == gREQUEST_STATUS_OK
          ) {
            alert("update thanh cong");
            onBtnBack();
          }
        };
      }
      // back
      function onBtnBack() {
        var vLink = "DanhSachDonHang.html";
        window.location.href = vLink;
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      // gọi api de lay data order
      function goiApiDeLayOrder(paramXmlHttp) {
        paramXmlHttp.open("GET", gBASE_URL_ORDER + "/" + gOrderCode, true);
        paramXmlHttp.send();
      }
      // ham hien thi thong tin input
      function hienThiThongTinOrder(paramXmlHttp) {
        var vOrderObj = JSON.parse(paramXmlHttp.responseText);
        var vInputOrderCode = document.getElementById("inp-ordercode");
        var vInputDuongKinh = document.getElementById("inp-duong-kinh");
        var vInputSuon = document.getElementById("inp-suon-nuong");
        var vInputSoLuongNuoc = document.getElementById("inp-so-luong-nuoc");
        var vInputVoucherId = document.getElementById("inp-id-voucher");
        var vInputSalad = document.getElementById("inp-salad");
        var vInputThanhTien = document.getElementById("inp-thanh-tien");
        var vInputGiamGia = document.getElementById("inp-giam-gia");
        var vInputHoTen = document.getElementById("inp-ho-ten");
        var vInputEmail = document.getElementById("inp-email");
        var vInputSoDienThoai = document.getElementById("inp-so-dien-thoai");
        var vInputDiaChi = document.getElementById("inp-dia-chi");
        var vInputLoiNhan = document.getElementById("inp-loi-nhan");
        var vInputTrangThai = document.getElementById("inp-trang-thai");
        var vInputNgayTaoDon = document.getElementById("inp-ngay-tao");
        var vInputNgayCapNhat = document.getElementById("inp-ngay-cap-nhat");

        vInputOrderCode.value = vOrderObj.orderCode;
        vInputDuongKinh.value = vOrderObj.duongKinh;
        vInputSuon.value = vOrderObj.suon;
        vInputSoLuongNuoc.value = vOrderObj.soLuongNuoc;
        vInputVoucherId.value = vOrderObj.idVourcher;
        vInputSalad.value = vOrderObj.salad;
        vInputThanhTien.value = vOrderObj.thanhTien;
        vInputGiamGia.value = vOrderObj.giamGia;
        vInputEmail.value = vOrderObj.email;
        vInputSoDienThoai.value = vOrderObj.soDienThoai;
        vInputDiaChi.value = vOrderObj.diaChi;
        vInputLoiNhan.value = vOrderObj.loiNhan;
        vInputTrangThai.value = vOrderObj.trangThai;
        vInputNgayTaoDon.value = vOrderObj.ngayTao;
        vInputNgayCapNhat.value = vOrderObj.ngayCapNhat;
        vInputHoTen.value = vOrderObj.hoTen;

        var vSelectKichCo = document.getElementById("select-co-combo");
        vSelectKichCo.options[vSelectKichCo.selectedIndex].text =
          vOrderObj.kichCo;

        var vSelectDrink = document.getElementById("select-drink");
        vSelectDrink.options[vSelectDrink.selectedIndex].text =
          vOrderObj.idLoaiNuocUong;

        var vSelectLoaiPizza = document.getElementById("select-loai-pizza");
        vSelectLoaiPizza.options[vSelectLoaiPizza.selectedIndex].text =
          vOrderObj.loaiPizza;
      }
      // <!-- gọi api để lấy drink -->
      function goiApiDeLayDrink(paramXmlHttp) {
        paramXmlHttp.open("GET", gBASE_URL_DRINK, false);
        paramXmlHttp.send();
      }
      function hienThiThongTinNuoc(paramXmlHttp) {
        var vObjDrink = JSON.parse(paramXmlHttp.responseText);
        var vSelectDrink = document.getElementById("select-drink");
        if (paramXmlHttp.status == gREQUEST_STATUS_OK) {
          for (var bI = 0; bI < vObjDrink.length; bI++) {
            var vOptionDrink = document.createElement("option");
            vOptionDrink.value = vObjDrink[bI].maNuocUong;
            vOptionDrink.text = vObjDrink[bI].tenNuocUong;
            vSelectDrink.appendChild(vOptionDrink);
          }
        }
      }
      // goi api de update order
      function goiApiUpdateOrder(paramOrderObj, paramXmlHttp) {
        console.log(gId);
        var vJsonOrder = JSON.stringify(paramOrderObj);
        paramXmlHttp.open("PUT", gBASE_URL_ORDER + "/" + gId);
        paramXmlHttp.setRequestHeader(
          "Content-Type",
          "application/json;charset=UTF-8"
        );

        paramXmlHttp.send(vJsonOrder);
      }
    </script>

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script
      src="https://code.jquery.com/jquery-3.3.1.slim.min.js"
      integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"
      integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"
      integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM"
      crossorigin="anonymous"
    ></script>
  </body>
</html>
